% Exercise 3.1

% Add the path to the additional m-files
addpath('functions');
    
nvars = 2; % Number of dimensions of the search space
tournamentSize = 2; % Tournament size
popSize = 20; % Population size
popInitRange = [-10; 10]; % Range for the initial population
numGenerations = 50; % Number of generations of the GA
numRuns = 3; % Number of runs to be done for each condition
display = 1; % Plot initial and final populations

% Reserve space to save the best fitness of each run and for each condition
bestFitnesses = zeros(numRuns, 2);

% Only mutation, no crossover
stdev = 1; % Standard deviation of the Gaussian mutations
crossover = 0; % Crossover fraction

% Run GAs
for i = 1:numRuns
    [bestInd bestFit] = runGA(@fsphere, nvars, stdev, crossover, tournamentSize, popSize, popInitRange, numGenerations, display);
    bestFitnesses(i,1) = bestFit;
end

% Only crossover, no mutation
stdev = 0;
crossover = 1;

% Run GAs
for i = 1:numRuns
    [bestInd bestFit] = runGA(@fsphere, nvars, stdev, crossover, tournamentSize, popSize, popInitRange, numGenerations, display);
    bestFitnesses(i,2) = bestFit;
end

% Boxplot comparing the best fitnesses
figure;
boxplot(bestFitnesses, 'notch', 'on');
set(gca,'YScale','log')
ylabel('Best fitness');

