% Exercise 4

% Add the path to the additional m-files
addpath('functions');
    
% -------------------------------------------------------------------------
% Edit this part to do the exercises

tournamentSize = [2 10]; % Tournament size
fitnessFunct = @fsphere;
%fitnessFunct = @frastrigin;

% -------------------------------------------------------------------------

nvars = 1; % Number of dimensions of the search space
stdev = 0.2; % Standard deviation of the Gaussian mutations
crossover = 0; % Crossover fraction
popSize = 25; % Population size
popInitRange = [-10; 10]; % Range for the initial population
numGenerations = 50; % Number of generations of the GA
display = 1; % Plot initial and final populations
numRuns = 10; % Number of runs to be done for each tournament size

% Reserve space to save the distance from the global optimum of the best
% individual of each run
distanceFromGlobalOptimum = zeros(numRuns, length(stdev));
% Reserve space to save the fitness of the best individual of each run
bestFitnesses = zeros(numRuns, length(stdev));

% Run GAs
for i = 1:length(tournamentSize)
    for j = 1:numRuns
        [bestInd bestFit] = runGA(fitnessFunct, nvars, stdev, crossover, tournamentSize(i), popSize, popInitRange, numGenerations, display);
        distanceFromGlobalOptimum(j,i) = sqrt(sum(bestInd.^2));
        bestFitnesses(j,i) = bestFit;
    end
end

% Boxplot comparing the distance from the global optimum
figure;
subplot(2,1,1);
boxplot(distanceFromGlobalOptimum, 'notch', 'on');
ylabel('Distance from optimum');

% Boxplot comparing the best fitnesses
subplot(2,1,2);
boxplot(bestFitnesses, 'notch', 'on');
ylabel('Fitness');


  


  

